<?php

	/*
		Plugin Name: Custom User Emails
		Description: This is a plugin to simply and easily modify wordpress's default emails subject and body.
		Version: 1.1.1
		Author: Creative Pixel Press
		Author URI: http://CreativePixelPress.com
		License: GPLv2 or later
	*/

	/* ----------------------------------------------------------------------------- */
	/* PLUGIN -> ADMIN																 */
	/* ----------------------------------------------------------------------------- */
	
		add_action ( 'admin_menu', 'cpp_cue_admin_add_page' );
		add_action ( 'admin_init', 'cpp_cue_admin_init' );

		function cpp_cue_admin_add_page ( ) {
			if(!cpp_cue_find_menu_item('cpp')){
				add_menu_page('fj1','Creative Pixel Press', 'manage-options', 'cpp');//, array($this, 'main')echo 'here1';exit;
			}
			if(!function_exists('remove_submenu_page')) {
				unset($GLOBALS['submenu']['cpp'][0]);
			}
			else {
				remove_submenu_page('cpp','cpp');
			}
			$adminpage = add_submenu_page('cpp', 'Custom User Emails', 'Custom User Emails', 'administrator', 'cpp_cue', 'cpp_cue_options_page');
		}
		
		function cpp_cue_find_menu_item($handle, $sub = false) {
			if(!is_admin() || (defined('DOING_AJAX') && DOING_AJAX)) {
				return false;
			}
			
			global $menu, $submenu;
			$check_menu = $sub ? $submenu : $menu;
			if(empty($check_menu)) {
				return false;
			}
			foreach($check_menu as $k => $item) {
				if($sub) {
					foreach($item as $sm) {
						if($handle == $sm[2]) {
							return true;
						}
					}
				}
				else {
					if($handle == $item[2]) {
						return true;
					}
				}
			}
			return false;
		}
		
		function cpp_cue_options_page ( ) {
			
			?>
			<div class="wrap">
				
				<h1>Customise User Emails</h1>
				
				<p>
				
					<a href="admin.php?page=cpp_cue">Edit Welcome Email</a> | 
					<a href="admin.php?page=cpp_cue&subsection=pwreminder">Edit Password Reset Email</a>			
				
				</p>

				<?php
				
					if ( !isset ( $_GET [ 'subsection' ] ) ) {
						
						$_GET [ 'subsection' ] = '';
					
					}
				
					switch ( $_GET [ 'subsection' ] ) {
					
						default:
							
							require_once 'includes/welcome-email.php';
						
						break;
						
						case "pwreminder":
						
							require_once 'includes/password-reminder.php';
						
						break;
						
					}
				
				
				?>				
							
			</div>
		<?php			
			
		}
			
		
		function cpp_cue_options_validate ( $input ) {
			
			return $input;
				
		}		
		
		function cpp_cue_admin_init ( ) {

			register_setting ( 'cpp_cue_options', 'cpp_cue_options', 'cpp_cue_options_validate' );
	
		}

	/* ----------------------------------------------------------------------------- */
	/* MESSAGE -> PROCESS															 */
	/* ----------------------------------------------------------------------------- */
		
		// -> Overwrite the new user notification function in order to send our e-mail.
		if ( !function_exists ( 'wp_new_user_notification' ) ) {

			function wp_new_user_notification ( $User_ID, $Plaintext_Pass = '' ) {
				
				// -> Get the new user's ID.
				$User = new WP_User ( $User_ID );
				
				// -> Get the new user's details.
				$User_Login = stripslashes ( $User -> user_login );
				$User_Email = stripslashes ( $User -> user_email );
				$User_Firstname = stripslashes ( $User -> first_name );
				$User_Lastname = stripslashes ( $User -> last_name );

				// -> Build the admin payload.
				$Admin_Payload  = sprintf ( __( 'New user registration on %s:' ), get_option('blogname')) . "\r\n\r\n";
				$Admin_Payload .= sprintf ( __( 'Username: %s' ), $User_Login ) . "\r\n\r\n";
				$Admin_Payload .= sprintf ( __( 'E-mail: %s' ), $User_Email ) . "\r\n";
				
				// -> Send out an e-mail regardless of errors.
				@wp_mail ( get_option ( 'admin_email' ) , sprintf ( __( '[%s] New User Registration' ), get_option ( 'blogname' ) ), $Admin_Payload );
				
				// -> Return/do not continue if the password is null.
				if ( empty ( $Plaintext_Pass ) ) {
				 
					return;
					
				}
				
				// -> Globalise $wpdb.
				global $wpdb;

				// -> Generate the table name.
				$Templates_Table = $wpdb -> base_prefix . 'mailer_templates';
				
				// -> Get the current message from the database.
				$Current_Row = $wpdb -> get_results ( "select * from $Templates_Table where `message_type`='signup' limit 1", ARRAY_A );
				
				// -> Route the data around an array.
				foreach ( $Current_Row as $Row ) {	
				
					$Sender_Name = $Row [ 'sender_name' ];
					$From_Address = $Row [ 'from_address' ];
					$Message_Subject = $Row [ 'message_subject' ];
					$Template_Body = $Row [ 'template_body' ];
					
				}
				
				// -> Get the date and time formats for the shortcode.
				$Date_Format = get_option ( 'date_format' );
				$Time_Format = get_option ( 'time_format' );
				
				// !!! Now that the data is available, convert the shortcodes.
				$Template_Body = str_replace ( '[site_url]', site_url ( ), $Template_Body );
				$Template_Body = str_replace ( '[login_url]', wp_login_url ( ), $Template_Body ); 
				$Template_Body = str_replace ( '[user_email]', $User_Email, $Template_Body ); 
				$Template_Body = str_replace ( '[user_login]', $User_Login, $Template_Body ); 
				$Template_Body = str_replace ( '[plaintext_password]', $Plaintext_Pass, $Template_Body ); 
				$Template_Body = str_replace ( '[blog_name]', get_bloginfo ( 'name' ), $Template_Body ); 
				$Template_Body = str_replace ( '[admin_email]', get_bloginfo ( 'admin_email' ), $Template_Body ); 
				$Template_Body = str_replace ( '[user_id]', $User_ID, $Template_Body ); 
				$Template_Body = str_replace ( '[first_name]', $User_Firstname, $Template_Body ); 
				$Template_Body = str_replace ( '[last_name]', $User_Lastname, $Template_Body ); 
				$Template_Body = str_replace ( '[date]', date ( $Date_Format ), $Template_Body ); 
				$Template_Body = str_replace ( '[time]', date ( $Time_Format ), $Template_Body ); 

				// -> Prepare the headers.
				$Group_Headers = array ( );
				$Group_Headers [ ] = 'From: ' . $Sender_Name . ' <' . $From_Address . '>';
				$Group_Headers [ ] = 'Content-Type: text/html; charset=UTF-8';
				
				// -> Add line breaks to the body.
				$Template_Body = nl2br ( $Template_Body );

				// -> Strip out any slashes in the content.
				$Template_Body = stripslashes ( $Template_Body );
				
				// -> Send out the message.
				wp_mail ( $User_Email, $Message_Subject, $Template_Body, $Group_Headers );
					
			}
		
		}
				
		// -> Generate the message subject.
		function Retrieve_Password_Subject ( ) {

			// -> Globalise $wpdb.
			global $wpdb;

			// -> Generate the table name.
			$Templates_Table = $wpdb -> base_prefix . 'mailer_templates';
			
			// -> Get the current message from the database.
			$Current_Row = $wpdb -> get_results ( "select * from $Templates_Table where `message_type`='pwreminder' limit 1", ARRAY_A );
			
			// -> Route the data around an array.
			foreach ( $Current_Row as $Row ) {	
			
				$Message_Subject = $Row [ 'message_subject' ];
				
			}
			
			// -> Return the message subject.
			return $Message_Subject;
				
		}		
		
		// -> The password change e-mail must be modified via filters. Create the necessary filters and send.
		add_filter ( 'retrieve_password_title', 'Retrieve_Password_Subject' );

		// -> Set the content type to HTML.
		function Usermails_Content_Type ( ) {
		
			return 'text/html';
		
		}

		add_filter ( 'wp_mail_content_type', 'Usermails_Content_Type');		
		
		// -> Set the from e-mail address.		
		function Usermails_From_Address ( ) {

			// -> Globalise $wpdb.
			global $wpdb;

			// -> Generate the table name.
			$Templates_Table = $wpdb -> base_prefix . 'mailer_templates';
			
			// -> Get the current message from the database.
			$Current_Row = $wpdb -> get_results ( "select * from $Templates_Table where `message_type`='pwreminder' limit 1", ARRAY_A );
			
			// -> Route the data around an array.
			foreach ( $Current_Row as $Row ) {	
			
				$From_Address = $Row [ 'from_address' ];
				
			}
			
			// -> Return the message subject.
			return $From_Address;
			
		}
		
		add_filter ( 'wp_mail_from', 'Usermails_From_Address' );
		
		// -> Set the sender name.
		function Usermails_From_Name ( ) {

			// -> Globalise $wpdb.
			global $wpdb;

			// -> Generate the table name.
			$Templates_Table = $wpdb -> base_prefix . 'mailer_templates';
			
			// -> Get the current message from the database.
			$Current_Row = $wpdb -> get_results ( "select * from $Templates_Table where `message_type`='pwreminder' limit 1", ARRAY_A );
			
			// -> Route the data around an array.
			foreach ( $Current_Row as $Row ) {	
			
				$Sender_Name = $Row [ 'sender_name' ];
				
			}
			
			// -> Return the message subject.
			return $Sender_Name;
		
		}

		add_filter ( 'wp_mail_from_name', 'Usermails_From_Name' );

		// -> Generate the main body.
		function Retrieve_Password_Body ( $Message, $Key ) {
			
			global $wpdb;
						
			// -> Get the target username or e-mail from the post.
			$Post_Login = htmlentities ( $_POST [ 'user_login' ] );
			
			// -> Get the required variables.	
			$User_Get = $wpdb -> get_results ( "SELECT * FROM $wpdb->users WHERE (user_login='$Post_Login' OR user_email='$Post_Login') LIMIT 1" );
			
			// -> Route the data around an array.
			foreach ( $User_Get as $User_Row ) {	
								
				// -> If the relevant user is in the haystack return the result.
				$Target_ID = $User_Row -> ID;
				
			}			
			
			// -> Get the new user's ID.			
			$User = new WP_User ( $Target_ID );
				
			// -> Get the new user's details.
			$User_Login = stripslashes ( $User -> user_login );
			$User_Email = stripslashes ( $User -> user_email );
			$User_Firstname = stripslashes ( $User -> first_name );
			$User_Lastname = stripslashes ( $User -> last_name );
				
			// -> Generate the table name.
			$Templates_Table = $wpdb -> base_prefix . 'mailer_templates';
			
			// -> Get the current message from the database.
			$Current_Row = $wpdb -> get_results ( "select * from $Templates_Table where `message_type`='pwreminder' limit 1", ARRAY_A );
			
			// -> Route the data around an array.
			foreach ( $Current_Row as $Row ) {	
			
				$Sender_Name = $Row [ 'sender_name' ];
				$From_Address = $Row [ 'from_address' ];
				$Message_Subject = $Row [ 'message_subject' ];
				$Template_Body = $Row [ 'template_body' ];
				
			}
			
			// -> Get the date and time formats for the shortcode.
			$Date_Format = get_option ( 'date_format' );
			$Time_Format = get_option ( 'time_format' );
			
			// !!! Now that the data is available, convert the shortcodes.
			$Template_Body = str_replace ( '[site_url]', site_url ( ), $Template_Body );
			$Template_Body = str_replace ( '[login_url]', wp_login_url ( ), $Template_Body ); 
			$Template_Body = str_replace ( '[user_email]', $User_Email, $Template_Body ); 
			$Template_Body = str_replace ( '[user_login]', $User_Login, $Template_Body ); 
			$Template_Body = str_replace ( '[password_reset_url]', wp_login_url ( ) . '?action=rp&key=' . $Key . '&login=' . $User_Login, $Template_Body ); 
			$Template_Body = str_replace ( '[blog_name]', get_bloginfo ( 'name' ), $Template_Body ); 
			$Template_Body = str_replace ( '[admin_email]', get_bloginfo ( 'admin_email' ), $Template_Body ); 
			$Template_Body = str_replace ( '[user_id]', $Target_ID, $Template_Body ); 
			$Template_Body = str_replace ( '[first_name]', $User_Firstname, $Template_Body ); 
			$Template_Body = str_replace ( '[last_name]', $User_Lastname, $Template_Body ); 
			$Template_Body = str_replace ( '[date]', date ( $Date_Format ), $Template_Body ); 
			$Template_Body = str_replace ( '[time]', date ( $Time_Format ), $Template_Body ); 
			
			// -> Add line breaks to the body.
			$Template_Body = nl2br ( $Template_Body );
			
			// -> Strip out any slashes in the content.
			$Template_Body = stripslashes ( $Template_Body );
				
			// -> Return the result.
			return $Template_Body;
		
		}
		
		// -> Add the filter for the main body.
		add_filter ( 'retrieve_password_message', 'Retrieve_Password_Body', 10, 2 );
		
		
	/* ----------------------------------------------------------------------------- */
	/* DATABASE -> TABLE MANAGEMENT													 */
	/* ----------------------------------------------------------------------------- */		
		
		// -> Sets up tables on installation.
		function cpp_cue_database_installer ( ) {
			
			// -> Call $wpdb.
			global $wpdb;
			
			// -> Generate the table name.
			$Templates_Table = $wpdb -> base_prefix . 'mailer_templates';
			
			// -> Declare the SQL required to install the database.
			$Templates_Table_SQL = "CREATE TABLE $Templates_Table (
			
				id INT NOT NULL AUTO_INCREMENT,
				PRIMARY KEY(id),
				message_type VARCHAR(255),
				sender_name VARCHAR(255),
				from_address VARCHAR(255),
				message_subject VARCHAR(255),
				template_body TEXT
			
			)";

			// -> Call the database functions if they aren't already available.
			require_once ( ABSPATH . 'wp-admin/includes/upgrade.php' );
			
			// -> Execute the SQL code if the table doesn't already exist.
			if ( $wpdb -> get_var ( "SHOW TABLES LIKE '$Templates_Table'" ) != $Templates_Table ) {
			
				dbDelta ( $Templates_Table_SQL );
				
				// -> Set up the example entries.
				$wpdb -> insert ( 
									$Templates_Table, 
									array ( 
											'message_type' => 'signup', 
											'sender_name' => get_bloginfo ( 'name' ),
											'from_address' => get_bloginfo ( 'admin_email' ),
											'message_subject' => 'Welcome to ' . get_bloginfo ( 'name' ),
											'template_body' => 'This is an example email. Please update it with your own content'
									), 
									array ( 
											'%s', 
											'%s',
											'%s',
											'%s',
											'%s'
									) 
				);			

				$wpdb -> insert ( 
									$Templates_Table, 
									array ( 
											'message_type' => 'pwreminder', 
											'sender_name' => get_bloginfo ( 'name' ),
											'from_address' => get_bloginfo ( 'admin_email' ),
											'message_subject' => 'Password reminder for ' . get_bloginfo ( 'name' ),
											'template_body' => 'This is an example email. Please update it with your own content'
									), 
									array ( 
											'%s', 
											'%s',
											'%s',
											'%s',
											'%s'
									) 
				);					
			
			}			
			
		}
		
		// -> Destroys tables on uninstallation.
		function cpp_cue_database_uninstaller ( ) {
			
			// -> Call $wpdb.
			global $wpdb;
			
			// -> Generate the table name required by the plugin.
			$Templates_Table = $wpdb -> base_prefix . 'mailer_templates';
			
			// -> Use $wpdb to drop the plugin's table.
			$wpdb -> query ( "DROP TABLE IF EXISTS $Templates_Table" );
		
		}
	
	/* ----------------------------------------------------------------------------- */
	/* INIT -> ACTIVATION HOOKS														 */
	/* ----------------------------------------------------------------------------- */
		
		// -> Install the database if it isn't already there.
		register_activation_hook ( __FILE__, 'cpp_cue_database_installer' );

	/* ----------------------------------------------------------------------------- */
	/* INIT -> DEACTIVATION/UNINSTALL HOOKS											 */
	/* ----------------------------------------------------------------------------- */	

		// -> Uninstall the database if the plugin is uninstalled.
		register_uninstall_hook ( __FILE__, 'cpp_cue_database_uninstaller' );
	
?>